--- old/usr/src/cmd/mdb/common/modules/genunix/Makefile.files	Tue Oct 15 14:35:32 2019
+++ new/usr/src/cmd/mdb/common/modules/genunix/Makefile.files	Tue Oct 15 14:35:32 2019
@@ -21,7 +21,7 @@
 #
 # Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
 # Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
-# Copyright 2019, Joyent, Inc.
+# Copyright 2019 Joyent, Inc.
 # Copyright (c) 2013 by Delphix. All rights reserved.
 #
 
@@ -72,6 +72,7 @@
 	pci.c		\
 	pg.c		\
 	rctl.c		\
+	refstr.c	\
 	sobj.c		\
 	streams.c	\
 	sysevent.c	\
--- old/usr/src/cmd/mdb/common/modules/genunix/genunix.c	Tue Oct 15 14:35:32 2019
+++ new/usr/src/cmd/mdb/common/modules/genunix/genunix.c	Tue Oct 15 14:35:32 2019
@@ -4082,6 +4082,8 @@
 	    "  -x   report times in hexadecimal\n");
 }
 
+extern int cmd_refstr(uintptr_t, uint_t, int, const mdb_arg_t *);
+
 static const mdb_dcmd_t dcmds[] = {
 
 	/* from genunix.c */
@@ -4112,6 +4114,7 @@
 	{ "pgrep", "[-x] [-n | -o] pattern",
 		"pattern match against all processes", pgrep },
 	{ "ptree", NULL, "print process tree", ptree },
+	{ "refstr", NULL, "print string from a refstr_t", cmd_refstr, NULL },
 	{ "sysevent", "?[-sv]", "print sysevent pending or sent queue",
 		sysevent},
 	{ "sysevent_channel", "?", "print sysevent channel database",
--- /dev/null	Tue Oct 15 14:35:33 2019
+++ new/usr/src/cmd/mdb/common/modules/genunix/refstr.c	Tue Oct 15 14:35:33 2019
@@ -0,0 +1,43 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2019 Joyent, Inc.
+ */
+
+#include <mdb/mdb_modapi.h>
+#include <mdb/mdb_ks.h>
+#include <sys/refstr.h>
+
+#define	REFSTR_LEN (1024)
+
+int
+cmd_refstr(uintptr_t addr, uint_t flags __unused,
+    int argc, const mdb_arg_t *argv)
+{
+	if (!(flags & DCMD_ADDRSPEC)) {
+		mdb_warn("address is required\n");
+		return (DCMD_ERR);
+	}
+
+	if (mdb_getopts(argc, argv, NULL) != argc)
+		return (DCMD_USAGE);
+
+	char *buf = mdb_alloc(REFSTR_LEN, UM_SLEEP | UM_GC);
+
+	if (mdb_read_refstr(addr, buf, REFSTR_LEN) < 0) {
+		mdb_warn("couldn't read refstr from %p", addr);
+		return (DCMD_ERR);
+	}
+
+	mdb_printf("%s\n", buf);
+	return (DCMD_OK);
+}
